title 'Simulation of joint live and dead encounter histories';
%let noccas=5;
%let noccas2=%eval(&noccas*2);
data joint;
   array S{&noccas} _temporary_;
   array p{&noccas} _temporary_;
   array r{&noccas} _temporary_;
   array F{&noccas} _temporary_;
   length caphist capdead $ &noccas2;
   length caplive $ &noccas;
   noccas=&noccas;
   S[1]=0.9;   p[1]=1.0;   r[1]=0.1;   F[1]=0.95;
   S[2]=0.8;   p[2]=0.2;   r[2]=0.2;   F[2]=0.90;
   S[3]=0.7;   p[3]=0.3;   r[3]=0.3;   F[3]=0.85;
   S[4]=0.8;   p[4]=0.4;   r[4]=0.4;   F[4]=0.80;
   S[5]=0.9;   p[5]=0.3;   r[5]=0.1;   F[5]=0.75;
/*
*/
   do icap=1 to noccas;
      do indiv=1 to 1000000;
         do i=1 to &noccas2;
            substr(caphist,i,1)='0';
            substr(capdead,i,1)='0';
         end;
         do i=1 to noccas;
            substr(caplive,i,1)='0';
         end;
         substr(caphist,icap*2-1,1)='1';
         substr(caplive,icap,1)='1';
         substr(capdead,icap*2-1,1)='1';
         stillput=1;
         stillive=1;
         i=icap;
         do while (i<=noccas & stillive=1);
            * Live recapture? Only if still on area. ;
            if i>icap & stillput=1 then do;
               * Was animal caught?;
               if ranuni(0)<p[i] then do;
                  j=i*2-1;
                  substr(caphist,j,1)='1';
                  substr(caplive,i,1)='1';
               end;
            end;
            * Emigration?;
            if ranuni(0)>F[i] then stillput=0;
            * Live through the interval?;
            if ranuni(0)>S[i] then do;
               stillive=0;
               if ranuni(0)<r[i] then do;
                  j=i*2;
                  substr(caphist,j,1)='1';
                  substr(capdead,j,1)='1';
               end;
            end;
            i=i+1;
         end;
         keep caphist capdead caplive;
         output;
      end;
   end;
*proc print;
proc freq noprint data=joint;
   tables caphist / out=caps;
proc print data=caps;
data out;
   set caps;
   file 'marks1.inp';
   put caphist count ';';
proc freq noprint data=joint;
   tables capdead / out=caps;
proc print data=caps;
data out;
   set caps;
   file 'marks2.inp';
   put capdead count ';';
proc freq noprint data=joint;
   tables caplive / out=caps;
proc print data=caps;
data out;
   set caps;
   file 'marks3.inp';
   put caplive count ';';
run;
